#! /bin/sh

host_name=127.0.0.1
server_bin=
monitor_bin=

team1_name=dvanasty_hrac
team1_bin=./player
coach1_bin=./coach

team2_name=
team2_bin=./player
coach2_bin=./coach

until [ $# = 0 ]; do
  case "$1" in
    (-host|-hostname|-host[-_]name)
      shift
      host_name="$1"
      ;;
    (-server[-_]bin|-server)
      shift
      server_bin="$1"
      ;;
    (-monitor[-_]bin|-monitor)
      shift
      monitor_bin="$1"
      ;;
    (-team1[-_]name|-team[-_]name)
      shift
      team1_name="$1"
      ;;
    (-team1[-_]bin|-team[-_]bin)
      shift
      team1_bin="$1"
      ;;
    (-team2[-_]name)
      shift
      team2_name="$1"
      ;;
    (-team2[-_]bin)
      shift
      team2_bin="$1"
      ;;
    (-coach1[-_]bin|-coach[-_]bin|-coach1|-coach)
      shift
      coach1_bin="$1"
      ;;
    (-coach2[-_]bin|-coach2)
      shift
      coach2_bin="$1"
      ;;
    (*)
      echo "$0: Unknown option: $1"
      exit 1
      ;;
  esac

  shift
done

#server
if [ -n "$server_bin" ]; then
  "$server_bin" &
  sleep 1
fi

[ -n "$host_name" ] || exit

#monitor
if [ -n "$monitor_bin" ]; then
  "$monitor_bin" "$host_name" &
  sleep 1
fi

#team 1
if [ -n "$team1_bin" ] && [ -n "$team1_name" ]; then
    "$team1_bin" -n 1 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 2 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 3 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 4 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 5 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 6 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 7 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 8 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 9 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 10 -t $team1_name -h "$host_name" &
    sleep 1
    "$team1_bin" -n 11 -t $team1_name -h "$host_name" &
fi

#coach 1
if [ -n "$coach1_bin" ] && [ -n "$team1_name" ]; then
    "$coach1_bin" -t "$team1_name" -h "$host_name" &
fi

#team 2
if [ -n "$team2_bin" ] && [ -n "$team2_name" ]; then
    "$team2_bin" -n 1 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 2 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 3 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 4 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 5 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 6 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 7 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 8 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 9 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 10 -t $team2_name -h "$host_name" &
    sleep 1
    "$team2_bin" -n 11 -t $team2_name -h "$host_name" &
fi

#coach 2
if [ -n "$coach2_bin" ] && [ -n "$team2_name" ]; then
    "$coach2_bin" -t "$team2_name" -h "$host_name" &
fi
