#include "SituationsLog.h"
#include <stdio.h>
#include <math.h>

SituationsLog::SituationsLog(int iPlayerNr, const char* strTeamName)
{
  // try to open file
  char filename[255];
  sprintf(filename, "%s-#%.2i", strTeamName, iPlayerNr); 
  log = fopen(filename, "w+");
  
  if (log == 0)
  	printf("\nError opening file'%s'", filename);
  else
    printf("\nLog file succesfully opened\n");

  // printf XML header    
  fprintf(log, "<?xml version=\"1.0\" standalone=\"yes\"?>\n");
  fprintf(log, "<Situations xmlns=\"http://www2.dcs.elf.stuba.sk/TeamProject/2006/team03/SituationsSchema.xsd\">\n");      
}
 
SituationsLog::~SituationsLog()
{
  fprintf(log, "</Situations>\n"); 
  fclose(log);	
}

void SituationsLog::situationBegin(const char* strType, int iTime)
{
  fprintf(log, "  <Situation type=\"%s\" time=\"%i\">\n", strType, iTime);
}

void SituationsLog::situationEnd()
{
  fprintf(log, "  </Situation>");
}
  
void SituationsLog::addObject(const char strType[], double iX, double iY, const char color[])
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" color=\"%s\" />\n", (int)round(iX), (int)round(iY), strType, color);
}

void SituationsLog::addObject(const char strType[], double iX, double iY, const char color[], double value)
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" color=\"%s\" value=\"%.2f\" />\n", (int)round(iX), (int)round(iY), strType, color, value);
}

void SituationsLog::addObject(const char strType[], double dX, double dY)
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" />\n", (int)round(dX), (int)round(dY), strType);
}

void SituationsLog::addObject(const char strType[], double dX, double dY, double dX2, double dY2)
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" x2=\"%i\" y2=\"%i\" />\n", (int)round(dX), (int)round(dY), strType, (int)round(dX2), (int)round(dY2));
}

void SituationsLog::addObject(const char strType[], double dX, double dY, double dX2, double dY2, const char color[])
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" x2=\"%i\" y2=\"%i\" color=\"%s\" />\n", (int)round(dX), (int)round(dY), strType, (int)round(dX2), (int)round(dY2), color);
}

void SituationsLog::addObject(const char strType[], double dX, double dY, double dX2, double dY2, const char color[], double value)
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" x2=\"%i\" y2=\"%i\" color=\"%s\" value=\"%.2f\" />\n", (int)round(dX), (int)round(dY), strType, (int)round(dX2), (int)round(dY2), color, value);
}

void SituationsLog::addObject(const char strType[], double dX, double dY, double radius)
{
  fprintf(log, "    <Object x=\"%i\" y=\"%i\" type=\"%s\" radius=\"%i\" />\n", (int)round(dX), (int)round(dY), strType, (int)round(radius));
}
