package robocup.component;

import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Properties;
import robocup.component.actionfactories.AttentionToActionFactory;
import robocup.component.actionfactories.TurnNeckActionFactory;
import robocup.component.actions.AttentionToAction;
import robocup.component.actions.ChangeViewModeAction;
import robocup.component.actions.DashAction;
import robocup.component.actions.TurnNeckAction;

public class RunTest {

    

    /**
     * This method loads the properties of an agent from a file with a given
     * filename. It is used to create a <code>Property</code> object out
     * of the given paths during startup of the agents (@see main()).
     * 
     * @param fileName
     *            file with properties
     * @return Properties - loaded properties
     */
    public static Properties loadProperties(String fileName) {
        Properties p = new Properties();
        try {
            p.load(new FileInputStream(fileName));
        } catch (Exception e) {
            URL url = RobocupAgent.class.getClassLoader().getResource(fileName);
            if (url == null) {
                url = RobocupAgent.class.getClassLoader().getResource(
                        "etc/agents/" + fileName);
            }
            if (url == null) {
                e.printStackTrace();
                return null;
            }
            try {
                p.load(new FileInputStream(url.getFile()));
            } catch (Exception e1) {
                e1.printStackTrace();
                return null;
            }
        }

        return p;
    }
}
