/*LICENSE_BEGIN
 * ******************************************************************
 * Copyright 2006 by the Dainamite Robocup-Team at the
 * DAI-Labor, TU-Berlin (www.dai-labor.de)
 * 
 * Members of Dainamite are:
 * Holger Endert
 * Robert Wetzker
 * Thomas Karbe
 * Axel Heßler
 * Philippe Bütter
 * Felix Brossmann
 * 
 * Licensed under the GNU GPL (General Public License) Free Software 
 * License, Version 2. You may use this file only in compliance with 
 * the License. You may obtain a copy of the License at:
 * 
 * http://www.fsf.org/licensing/licenses/gpl.txt
 * ******************************************************************
LICENSE_END*/
/*
 * Created on 07.01.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package robocup.component.infotypes;

/**
 * This class is a super-type for the info-objects of the coach, and represents 
 * those, that have at least a position.
 */
public class CoachVisualObjectInfo extends Info {

	/**
	 * The x-coordinate of the position of this object.
	 */
	protected double xPos;

	/**
	 * The y-coordinate of the position of this object.
	 */
	protected double yPos;

	/**
	 * Constructs a generic visual info object for the coach - everything that
	 * has at least a psoition (player/ball)
	 * 
	 * @param iCycle -
	 *            when was it seen
	 * @param xPos -
	 *            the position (x-value)
	 * @param yPos -
	 *            the position (y-value)
	 */
	public CoachVisualObjectInfo(int iCycle, double xPos, double yPos) {
		super(iCycle);
		this.xPos = xPos;
		this.yPos = yPos;
	}

	/**
	 * @return Returns the xPos.
	 */
	public double getXPos() {
		return this.xPos;
	}

	/**
	 * @return Returns the yPos.
	 */
	public double getYPos() {
		return this.yPos;
	}

	/**
	 * Sets the x-coordinate of this object.
	 * @param pos - the x-position value.
	 */
	public void setXPos(double pos) {
		this.xPos = pos;
	}

	/**
	 * Sets the y-coordinate of this object.
	 * @param pos - the y-position value.
	 */
	public void setYPos(double pos) {
		this.yPos = pos;
	}
}
