/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.model;

import java.awt.Color;

import soccerscope.training.ObjectTrainingModel;
import soccerscope.util.geom.Point2f;

public class Ball extends SoccerObject {
	// player mode
	public final static int DISABLE = 0x0000;

	public final static int STAND = 0x0001;

	public int mode; // mode(DISABLE or STAND)

	// training-purposes:
	ObjectTrainingModel otm = null;

	public Ball() {
		super();
		this.mode = DISABLE;
	}

	public boolean isEnable() {
		return ((this.mode & STAND) == STAND);
	}

	@Override
	public Color getColor() {
		return ColorDB.getColor("ball");
	}

	@Override
	public void setPosition(Point2f pos) {
		super.setPosition(pos);
	}

}
