/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util;

import java.awt.Color;
import java.util.Hashtable;

public class Color2 {

	public final static Color aliceBlue = new Color(240, 248, 255);

	public final static Color antiqueWhite = new Color(250, 235, 215);

	public final static Color aquamarine = new Color(127, 255, 212);

	public final static Color azure = new Color(240, 255, 255);

	public final static Color beige = new Color(245, 245, 220);

	public final static Color bisque = new Color(255, 228, 196);

	public final static Color black = new Color(0, 0, 0);

	public final static Color blanchedAlmond = new Color(255, 235, 205);

	public final static Color blue = new Color(0, 0, 255);

	public final static Color blueViolet = new Color(138, 43, 226);

	public final static Color brown = new Color(165, 42, 42);

	public final static Color burlywood = new Color(222, 184, 135);

	public final static Color cadetBlue = new Color(95, 158, 160);

	public final static Color chartreuse = new Color(127, 255, 0);

	public final static Color chocolate = new Color(210, 105, 30);

	public final static Color coral = new Color(255, 127, 80);

	public final static Color cornflowerBlue = new Color(100, 149, 237);

	public final static Color cornsilk = new Color(255, 248, 220);

	public final static Color cyan = new Color(0, 255, 255);

	public final static Color darkBlue = new Color(0, 0, 139);

	public final static Color darkCyan = new Color(0, 139, 139);

	public final static Color darkGoldenrod = new Color(184, 134, 11);

	public final static Color darkGray = new Color(169, 169, 169);

	public final static Color darkGreen = new Color(0, 100, 0);

	public final static Color darkKhaki = new Color(189, 183, 107);

	public final static Color darkMagenta = new Color(139, 0, 139);

	public final static Color darkOliveGreen = new Color(85, 107, 47);

	public final static Color darkOrange = new Color(255, 140, 0);

	public final static Color darkOrchid = new Color(153, 50, 204);

	public final static Color darkRed = new Color(139, 0, 0);

	public final static Color darkSalmon = new Color(233, 150, 122);

	public final static Color darkSeaGreen = new Color(143, 188, 143);

	public final static Color darkSlateBlue = new Color(72, 61, 139);

	public final static Color darkSlateGray = new Color(47, 79, 79);

	public final static Color darkTurquoise = new Color(0, 206, 209);

	public final static Color darkViolet = new Color(148, 0, 211);

	public final static Color deepPink = new Color(255, 20, 147);

	public final static Color deepSkyBlue = new Color(0, 191, 255);

	public final static Color dimGray = new Color(105, 105, 105);

	public final static Color dodgerBlue = new Color(30, 144, 255);

	public final static Color firebrick = new Color(178, 34, 34);

	public final static Color floralWhite = new Color(255, 250, 240);

	public final static Color forestGreen = new Color(34, 139, 34);

	public final static Color gainsboro = new Color(220, 220, 220);

	public final static Color ghostWhite = new Color(248, 248, 255);

	public final static Color gold = new Color(255, 215, 0);

	public final static Color goldenrod = new Color(218, 165, 32);

	public final static Color gray = new Color(190, 190, 190);

	public final static Color green = new Color(0, 255, 0);

	public final static Color greenYellow = new Color(173, 255, 47);

	public final static Color honeydew = new Color(240, 255, 240);

	public final static Color hotPink = new Color(255, 105, 180);

	public final static Color indianRed = new Color(205, 92, 92);

	public final static Color ivory = new Color(255, 255, 240);

	public final static Color khaki = new Color(240, 230, 140);

	public final static Color lavender = new Color(230, 230, 250);

	public final static Color lavenderBlush = new Color(255, 240, 245);

	public final static Color lawnGreen = new Color(124, 252, 0);

	public final static Color lemonChiffon = new Color(255, 250, 205);

	public final static Color lightBlue = new Color(173, 216, 230);

	public final static Color lightCoral = new Color(240, 128, 128);

	public final static Color lightCyan = new Color(224, 255, 255);

	public final static Color lightGoldenrod = new Color(238, 221, 130);

	public final static Color lightGoldenrodYellow = new Color(250, 250, 210);

	public final static Color lightGray = new Color(211, 211, 211);

	public final static Color lightGreen = new Color(144, 238, 144);

	public final static Color lightPink = new Color(255, 182, 193);

	public final static Color lightSalmon = new Color(255, 160, 122);

	public final static Color lightSeaGreen = new Color(32, 178, 170);

	public final static Color lightSkyBlue = new Color(135, 206, 250);

	public final static Color lightSlateBlue = new Color(132, 112, 255);

	public final static Color lightSlateGray = new Color(119, 136, 153);

	public final static Color lightSteelBlue = new Color(176, 196, 222);

	public final static Color lightYellow = new Color(255, 255, 224);

	public final static Color limeGreen = new Color(50, 205, 50);

	public final static Color linen = new Color(250, 240, 230);

	public final static Color magenta = new Color(255, 0, 255);

	public final static Color maroon = new Color(176, 48, 96);

	public final static Color mediumAquamarine = new Color(102, 205, 170);

	public final static Color mediumBlue = new Color(0, 0, 205);

	public final static Color mediumOrchid = new Color(186, 85, 211);

	public final static Color mediumPurple = new Color(147, 112, 219);

	public final static Color mediumSeaGreen = new Color(60, 179, 113);

	public final static Color mediumSlateBlue = new Color(123, 104, 238);

	public final static Color mediumSpringGreen = new Color(0, 250, 154);

	public final static Color mediumTurquoise = new Color(72, 209, 204);

	public final static Color mediumVioletRed = new Color(199, 21, 133);

	public final static Color midnightBlue = new Color(25, 25, 112);

	public final static Color mintCream = new Color(245, 255, 250);

	public final static Color mistyRose = new Color(255, 228, 225);

	public final static Color moccasin = new Color(255, 228, 181);

	public final static Color navajoWhite = new Color(255, 222, 173);

	public final static Color navy = new Color(0, 0, 128);

	public final static Color navyBlue = new Color(0, 0, 128);

	public final static Color oldLace = new Color(253, 245, 230);

	public final static Color oliveDrab = new Color(107, 142, 35);

	public final static Color orange = new Color(255, 165, 0);

	public final static Color orangeRed = new Color(255, 69, 0);

	public final static Color orchid = new Color(218, 112, 214);

	public final static Color paleGoldenrod = new Color(238, 232, 170);

	public final static Color paleGreen = new Color(152, 251, 152);

	public final static Color paleTurquoise = new Color(175, 238, 238);

	public final static Color paleVioletRed = new Color(219, 112, 147);

	public final static Color papayaWhip = new Color(255, 239, 213);

	public final static Color peachPuff = new Color(255, 218, 185);

	public final static Color peru = new Color(205, 133, 63);

	public final static Color pink = new Color(255, 192, 203);

	public final static Color plum = new Color(221, 160, 221);

	public final static Color powderBlue = new Color(176, 224, 230);

	public final static Color purple = new Color(160, 32, 240);

	public final static Color red = new Color(255, 0, 0);

	public final static Color rosyBrown = new Color(188, 143, 143);

	public final static Color royalBlue = new Color(65, 105, 225);

	public final static Color saddleBrown = new Color(139, 69, 19);

	public final static Color salmon = new Color(250, 128, 114);

	public final static Color sandyBrown = new Color(244, 164, 96);

	public final static Color seaGreen = new Color(46, 139, 87);

	public final static Color seashell = new Color(255, 245, 238);

	public final static Color sienna = new Color(160, 82, 45);

	public final static Color skyBlue = new Color(135, 206, 235);

	public final static Color slateBlue = new Color(106, 90, 205);

	public final static Color slateGray = new Color(112, 128, 144);

	public final static Color snow = new Color(255, 250, 250);

	public final static Color springGreen = new Color(0, 255, 127);

	public final static Color steelBlue = new Color(70, 130, 180);

	public final static Color tan = new Color(210, 180, 140);

	public final static Color thistle = new Color(216, 191, 216);

	public final static Color tomato = new Color(255, 99, 71);

	public final static Color turquoise = new Color(64, 224, 208);

	public final static Color violet = new Color(238, 130, 238);

	public final static Color violetRed = new Color(208, 32, 144);

	public final static Color wheat = new Color(245, 222, 179);

	public final static Color white = new Color(255, 255, 255);

	public final static Color whiteSmoke = new Color(245, 245, 245);

	public final static Color yellow = new Color(255, 255, 0);

	public final static Color yellowGreen = new Color(154, 205, 50);

	private static Hashtable<Object, Object> colorTable = new Hashtable<Object, Object>();

	private Color2() {
	}

	static {
		putColor("aliceblue", aliceBlue);
		putColor("antiquewhite", antiqueWhite);
		putColor("aquamarine", aquamarine);
		putColor("azure", azure);
		putColor("beige", beige);
		putColor("bisque", bisque);
		putColor("black", black);
		putColor("blanchedalmond", blanchedAlmond);
		putColor("blue", blue);
		putColor("blueviolet", blueViolet);
		putColor("brown", brown);
		putColor("burlywood", burlywood);
		putColor("cadetblue", cadetBlue);
		putColor("chartreuse", chartreuse);
		putColor("chocolate", chocolate);
		putColor("coral", coral);
		putColor("cornflowerblue", cornflowerBlue);
		putColor("cornsilk", cornsilk);
		putColor("cyan", cyan);
		putColor("darkblue", darkBlue);
		putColor("darkcyan", darkCyan);
		putColor("darkgoldenrod", darkGoldenrod);
		putColor("darkgray", darkGray);
		putColor("darkgreen", darkGreen);
		putColor("darkkhaki", darkKhaki);
		putColor("darkmagenta", darkMagenta);
		putColor("darkolivegreen", darkOliveGreen);
		putColor("darkorange", darkOrange);
		putColor("darkorchid", darkOrchid);
		putColor("darkred", darkRed);
		putColor("darksalmon", darkSalmon);
		putColor("darkseagreen", darkSeaGreen);
		putColor("darkslateblue", darkSlateBlue);
		putColor("darkslategray", darkSlateGray);
		putColor("darkturquoise", darkTurquoise);
		putColor("darkviolet", darkViolet);
		putColor("deeppink", deepPink);
		putColor("deepskyblue", deepSkyBlue);
		putColor("dimgray", dimGray);
		putColor("dodgerblue", dodgerBlue);
		putColor("firebrick", firebrick);
		putColor("floralwhite", floralWhite);
		putColor("forestgreen", forestGreen);
		putColor("gainsboro", gainsboro);
		putColor("ghostwhite", ghostWhite);
		putColor("gold", gold);
		putColor("goldenrod", goldenrod);
		putColor("gray", gray);
		putColor("green", green);
		putColor("greenyellow", greenYellow);
		putColor("honeydew", honeydew);
		putColor("hotpink", hotPink);
		putColor("indianred", indianRed);
		putColor("ivory", ivory);
		putColor("khaki", khaki);
		putColor("lavender", lavender);
		putColor("lavenderblush", lavenderBlush);
		putColor("lawngreen", lawnGreen);
		putColor("lemonchiffon", lemonChiffon);
		putColor("lightblue", lightBlue);
		putColor("lightcoral", lightCoral);
		putColor("lightcyan", lightCyan);
		putColor("lightgoldenrod", lightGoldenrod);
		putColor("lightgoldenrodyellow", lightGoldenrodYellow);
		putColor("lightgray", lightGray);
		putColor("lightgreen", lightGreen);
		putColor("lightpink", lightPink);
		putColor("lightsalmon", lightSalmon);
		putColor("lightseagreen", lightSeaGreen);
		putColor("lightskyblue", lightSkyBlue);
		putColor("lightslateblue", lightSlateBlue);
		putColor("lightslategray", lightSlateGray);
		putColor("lightsteelblue", lightSteelBlue);
		putColor("lightyellow", lightYellow);
		putColor("limegreen", limeGreen);
		putColor("linen", linen);
		putColor("magenta", magenta);
		putColor("maroon", maroon);
		putColor("mediumaquamarine", mediumAquamarine);
		putColor("mediumblue", mediumBlue);
		putColor("mediumorchid", mediumOrchid);
		putColor("mediumpurple", mediumPurple);
		putColor("mediumseagreen", mediumSeaGreen);
		putColor("mediumslateblue", mediumSlateBlue);
		putColor("mediumspringgreen", mediumSpringGreen);
		putColor("mediumturquoise", mediumTurquoise);
		putColor("mediumvioletred", mediumVioletRed);
		putColor("midnightblue", midnightBlue);
		putColor("mintcream", mintCream);
		putColor("mistyrose", mistyRose);
		putColor("moccasin", moccasin);
		putColor("navajowhite", navajoWhite);
		putColor("navy", navy);
		putColor("navyblue", navyBlue);
		putColor("oldlace", oldLace);
		putColor("olivedrab", oliveDrab);
		putColor("orange", orange);
		putColor("orangered", orangeRed);
		putColor("orchid", orchid);
		putColor("palegoldenrod", paleGoldenrod);
		putColor("palegreen", paleGreen);
		putColor("paleturquoise", paleTurquoise);
		putColor("palevioletred", paleVioletRed);
		putColor("papayawhip", papayaWhip);
		putColor("peachpuff", peachPuff);
		putColor("peru", peru);
		putColor("pink", pink);
		putColor("plum", plum);
		putColor("powderblue", powderBlue);
		putColor("purple", purple);
		putColor("red", red);
		putColor("rosybrown", rosyBrown);
		putColor("royalblue", royalBlue);
		putColor("saddlebrown", saddleBrown);
		putColor("salmon", salmon);
		putColor("sandybrown", sandyBrown);
		putColor("seagreen", seaGreen);
		putColor("seashell", seashell);
		putColor("sienna", sienna);
		putColor("skyblue", skyBlue);
		putColor("slateblue", slateBlue);
		putColor("slategray", slateGray);
		putColor("snow", snow);
		putColor("springgreen", springGreen);
		putColor("steelblue", steelBlue);
		putColor("tan", tan);
		putColor("thistle", thistle);
		putColor("tomato", tomato);
		putColor("turquoise", turquoise);
		putColor("violet", violet);
		putColor("violetred", violetRed);
		putColor("wheat", wheat);
		putColor("white", white);
		putColor("whitesmoke", whiteSmoke);
		putColor("yellow", yellow);
		putColor("yellowgreen", yellowGreen);
	}

	public static void putColor(String colorName, Color c) {
		colorTable.put(colorName, c);
		colorTable.put(c, colorName);
	}

	public static String getColorName(Color c) {
		return (String) colorTable.get(c);
	}

	public static Color getColor(String colorName) {
		return (Color) colorTable.get(colorName.toLowerCase());
	}

	public static Color getColor(String colorName, Color defaultColor) {
		Color c = getColor(colorName);
		if (c != null) {
			return c;
		}
		return defaultColor;
	}

	public static Color mix(Color c1, Color c2, double x, double y) {
		int r = (int) ((x * c1.getRed() + y * c2.getRed()) / (x + y));
		int g = (int) ((x * c1.getGreen() + y * c2.getGreen()) / (x + y));
		int b = (int) ((x * c1.getBlue() + y * c2.getBlue()) / (x + y));

		return new Color(r, g, b);
	}

	public static Color mix2(Color c1, float x, float y) {
		float hsb[] = new float[3];
		hsb = Color.RGBtoHSB(c1.getRed(), c1.getGreen(), c1.getBlue(), null);
		hsb[2] = hsb[2] * x / (x + y);
		return new Color(Color.HSBtoRGB(hsb[0], hsb[1], hsb[2]));
	}

	public static float getHue(Color c) {
		float hsb[] = new float[3];
		hsb = Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), null);
		return hsb[0];
	}

	public static float getSaturation(Color c) {
		float hsb[] = new float[3];
		hsb = Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), null);
		return hsb[1];
	}

	public static float getBrightness(Color c) {
		float hsb[] = new float[3];
		hsb = Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), null);
		return hsb[2];
	}
}
