/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util.geom;

import java.util.Comparator;

public class Geometry {

	/**
	 * ٤[-180.180]
	 * 
	 * @param angle
	 *            
	 * @return 줿
	 */
	static public float normalizeAngle(float angle) {
		while (true) {
			if (angle < Math.toDegrees(-Math.PI))
				angle += 2 * Math.toDegrees(Math.PI);
			else if (angle > Math.toDegrees(Math.PI))
				angle -= 2 * Math.toDegrees(Math.PI);
			else
				break;
		}
		return angle;
	}

	/**
	 * ꤷ2ĤTuple2f֥t1,t2¤Tuple2f֥Ȥ֤.
	 * 
	 * @param t1
	 *            Tuple2f֥
	 * @param t2
	 *            Tuple2f֥
	 * @return Tuple2f֥
	 */
	public static Tuple2f add(Tuple2f t1, Tuple2f t2) {
		return new Tuple2f(t1.x + t2.x, t1.y + t2.y);
	}

	/**
	 * ꤷ2ĤTuple2f֥t1,t2κTuple2f֥Ȥ֤.
	 * 
	 * @param t1
	 *            Tuple2f֥
	 * @param t2
	 *            Tuple2f֥
	 * @return Tuple2f֥
	 */
	public static Tuple2f sub(Tuple2f t1, Tuple2f t2) {
		return new Tuple2f(t1.x - t2.x, t1.y - t2.y);
	}

	/**
	 * Tuple2f֥tžTuple2f֥Ȥ֤.
	 * 
	 * @param t
	 *            Tuple2f֥
	 * @return Tuple2f֥
	 */
	public static Tuple2f negate(Tuple2f t) {
		return new Tuple2f(-t.x, -t.y);
	}

	/**
	 * ꤷTuple2f֥taǼ¿ܤ̤Tuple2f֥Ȥ֤.
	 * 
	 * @param a
	 *            
	 * @param t
	 *            Tuple2f֥
	 * @return Tuple2f֥
	 */
	public static Tuple2f scale(float a, Tuple2f t) {
		return new Tuple2f(a * t.x, a * t.y);
	}

	/**
	 * Tuple2f֥t1aǼ¿ܤΤ,t2¤Tuple2f֥Ȥ֤. (=
	 * a*t1 + t2)
	 * 
	 * @param a
	 *            
	 * @param t1
	 *            ܤTuple2f֥
	 * @param t2
	 *            ûTuple2f֥
	 * @return Tuple2f֥
	 */
	public static Tuple2f scaleAdd(float a, Tuple2f t1, Tuple2f t2) {
		return new Tuple2f(a * t1.x + t2.x, a * t1.y + t2.y);
	}

	class SortX implements Comparator {
		public int compare(Object o1, Object o2) {
			return Float.compare(((Tuple2f) o1).x, ((Tuple2f) o2).x);
		}
	}

	class SortY implements Comparator {
		public int compare(Object o1, Object o2) {
			return Float.compare(((Tuple2f) o1).y, ((Tuple2f) o2).y);
		}
	}
}
