/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.view.layer;

import java.awt.Graphics;

import soccerscope.model.ClientScene;
import soccerscope.model.Param;
import soccerscope.model.SoccerObjectID;
import soccerscope.view.FieldPane;

// ܡ褹쥤䡼

public class BallLayer extends Layer implements SoccerObjectID {

	public BallLayer(FieldPane fieldPane) {
		super(fieldPane, true);
	}

	@Override
	public String getLayerName() {
		return "Ball";
	}

	@Override
	public void draw(Graphics g) {
		ClientScene clientScene = this.fieldPane.getScene();
		float ballMagnify = this.fieldPane.getBallMagnify();

		if (!clientScene.ball.isEnable())
			return;

		float ballR = Param.BALL_SIZE * ballMagnify;
		if (this.fieldPane.isOfflineSelected(BALL))
			g.setColor(clientScene.ball.getColor().darker());
		else
			g.setColor(clientScene.ball.getColor());
		fillCircle(g, clientScene.ball.pos, ballR);
	}
}
/*
 * $Log: BallLayer.java,v $
 * Revision 1.1.28.3  2006/11/23 09:41:02  endert
 * Added License Note at top of each *.java file.
 *
 * Revision 1.1.28.2  2006/07/31 13:36:30  endert
 * Added Java-Doc to constructors if missing, minor refactorings.
 * Revision 1.1.28.1 2006/07/26 15:28:27 endert
 * Formatted Code Revision 1.1 2006/03/13 07:37:43 axle moved from ROOT/src for
 * Maven 2 Buildsystem and Team/Soccerscope separation
 * 
 * Revision 1.3 2006/03/07 12:46:23 endert Merge after refactoring: - New
 * State-Interface: One Method for each action type - Action Bean removed -
 * ActionFactorys for helper methods, States calculate main-Action themselves -
 * formatted code - added State-List in Monitor (Context-Menu of Player) - other
 * smaller stuff
 * 
 * Revision 1.2.2.1 2006/02/25 22:07:05 wetzker formated
 * 
 * Revision 1.2 2006/02/22 16:04:59 endert This is done: - Rebound SoccerScope
 * to Agents (can be added or removed in config-file) - Situations now all
 * extend abstract class Situation - Refactorings: ActionBean _ removed from
 * Attributes - SoccerScope will automatically connect to host given in
 * Start-Call - Trainer uses the same host as soccerscope - Removed unused stuff
 * (old confs, bat, etc.) - Code formatted (good luck when merging) - organized
 * imports - all that i forgot to mention here Revision 1.1 2005/04/20 10:38:35
 * endert Fresh Team Repository installation from /home/e/endert/Robocup to
 * here.
 * 
 * Revision 1.3 2005/02/06 07:20:09 maketi Added soccerscope with connection to
 * our world model
 * 
 * Revision 1.5 2002/12/10 05:08:23 newone
 * 
 * Revision 1.4 2002/10/04 10:39:23 koji
 * 
 * Revision 1.3 2002/09/12 15:28:31 koji
 * 
 * Revision 1.2 2002/09/02 07:06:27 taku-ako
 * 
 * Revision 1.1.1.1 2002/03/01 14:12:52 koji
 * 
 */